import processing.serial.*;

PImage[] imgs = new PImage[8];
PrintWriter out;
Serial port;

void setup() {
  background(0);
  size(640,480);
  
  out = createWriter("log.txt");

  // initialize animation
  for (int i =0; i<8; i++) {
    imgs[i] = loadImage( "bike"+(i+1)+".png" );
  }
  
  // initialize serial port (adjust if your serial port is not 0)
  port = new Serial(this, Serial.list()[0], 9600);
  port.bufferUntil(10);
  
  // set initial framerate
  frameRate(8);
}

int idx = 0;

void draw() {
  noStroke();

  fill(210,220,255);
  rect(0,0,640,360);
  fill(128,200,128);
  rect(0,240,640,120);
  street();
  image( imgs[idx],0,0);
  
  idx++;
  if (idx == 8) idx = 0;
}

public void street() {
  fill(200,200,200);
  noStroke();
  rect(0,291,640,70);
}

int ov = 0;

void serialEvent( Serial port ) {
  String str = port.readStringUntil(10);
  if ( str != null ) {
    String[] arr = trim(str).split(" ");
    int value =  int( arr[1]);

    String what = "";
    
    // draw graph
    if (arr[0].equals("H1")) {
      stroke( 0, 255, 0 );
      line( width - 1, 420, width-1, 420 - ( value -ov)/16);
      what = "L ";
    } else {
      copy( 1, 360, width - 1, 120, 0, 360, width-1, 120 );
      stroke( 0 );
      line( width - 1, 360, width - 1, 480 );
      what = "R ";
    
      stroke( 255, 255, 0 );
      line( width - 1, 420, width-1, 420 + ( value -ov )/16);
    }

    // adjust framerate  
    if ( ov > 0 && (4000 / (value - ov )) > 3 ) {
      frameRate( 4000 / ( value - ov ));
    }

    out.println(what + (value - ov));
    out.flush();
    ov = value;
  }
}

void stop() {
  out.close();
}
